; 14.06.01
; ### Program pro zpracovani informace z rotacnich inkrementalnich cidel 
; bude to vice - mene jen procedua v preruseni
; ! je to navrzeno jako 16 bitove citace polohy bez hlidani podteceni 
; 16.07.01
; ### Ododelavana komunikace Ouranos
; - pro seriovou linku jsem nepouzil presuseni a je nastavena na 9600 Bd ....
; ! Pro zaporna a kladna cisla jsem pouzil dvojkovy doplnek FFFF = -1, 0000 = 0 
; 17.07.01
; Dopracovana ochrana preteceni pro nastaveni velikosti cidla
; Snaha o zrychleni oproti verzi citace1.a51
; 22.07.01
; Hotovo deleni dvema pri nastavovani delky cidla a inicializace na cidlo s 2500 impulzy
;
; 31.07.01
; CITACE21 v 2.1 provedena zmena v deklaraci baze equ 00000h vhodna pro AT89S8252 
; 01.08.01
; CITACE22 v 2.2 vlozena instrukce r 433 "setb TR1" pro spousteni citace casovace 1
; 02.08.01
; CITACE23 v 2.3 provedena zmena deklarace vstupnich pinu smeru R a D pro AT89S8252 
; 07.08.01
; Zmena nastaveni na prepocet z ofsetoveho tvaru na dvojkovy doplnek
; 14.08.01
; CITACE26 v 2.6 Zmena frekvence krystalu na 24 Mhz -> predelani uartu
; Zameneni smeru citani
; ###################################################
;            zacatek programu
baze		equ	00000h
procedury 	equ	baze+100h	; Na tomto miste budou zacinat me procedury
Promenne_citace	equ	30h		; Na tomto miste budou zacinat moje promenne
Smer_R		equ	P3.4		; Vstupni piny smeru R (REKTASCENZE) 
Smer_D		equ	P3.5		; Vstupni piny smeru D (DEKLINACE) 

cseg	
	org 	Baze
	jmp	start
	;********** Prerusovaci vektory
	org	baze+03h	; Vektor preruseni od INT0
	jmp 	Int_0		; Navrat z preruseni 
	org	baze+0bh	; Vektor preruseni od CT0
	reti			; Navrat z preruseni 	
	org	baze+13h	; Vektor preruseni od INT1
	jmp	Int_1		; Navrat z preruseni 
	org	baze+1bh	; Vektor preruseni od CT1
	reti			; Navrat z preruseni 
	org	baze+23h	; Vektor preruseni od UART
	reti			; Navrat z preruseni 

cseg    
	org	procedury 
; ***** Moje procedury
; Obsluha prerueni INT 0
Int_0:
	cpl	p1.4		; Ladeni
	push	ACC
	push	PSW
	clr	C		; Vynuluju si C
	mov	A,citac_R	; Nacte spodni byte do A
	jnb	smer_R,Int0_dec	; Podle smetu toceni cidla bud odecte nebo pricte
	add	A,#1		; Inkrementuje spodni byte citace
	mov	citac_R,A	; Ulozei spodniho byte 
	mov	A,citac_R+1	; Nacteni horniho byte do A
	addc	A,#0		; Inkrementuje horni byte pokud nastalo C
	mov	citac_R+1,A	; Ulozeni horniho byte
	;****** Zajisteni spravne delky
	rlc	A		; Test na zapornost ci kladnost
	jc	Int0_konec	; Pokud je zaporny nemohlo pretect pri pricitani prez rozsah citace
	setb	C		; * Odecteni Rozsahu
	mov	A,citac_R		; Lo byte
	subb	A,max_R
	mov	A,citac_R+1		; Hi byte
	subb	A,max_R+1
	jc	Int0_konec
	mov	citac_R+1,max_Rm+1
	mov	citac_R,max_Rm
Int0_konec:
	pop	PSW
	pop 	ACC
	reti 
Int0_dec:
	subb	A,#1		; Dekrementuje spodni byte citace
	mov	citac_R,A	; Ulozei spodniho byte 
	mov	A,citac_R+1	; Nacteni horniho byte do A
	subb	A,#0		; Dekrementuje se horni byte pokud nastalo C
	mov	citac_R+1,A	; Ulozeni horniho byte
	mov	R0,#citac_R
	mov	R1,#max_R
	;****** Zajisteni spravne delky
	rlc	A		; Test na zapornost ci kladnost
	jnc	Int0_konec	; Pokud je kladny nemohlo pretect pri odcitani prez rozsah citace
	setb	C		; * Odecteni Rozsahu
	mov	A,citac_R		; Lo byte
	addc	A,max_R
	mov	A,citac_R+1		; Hi byte
	addc	A,max_R+1
	jc	Int0_konec
	mov	citac_R+1,max_R+1
	mov	citac_R,max_R
	pop	PSW
	pop 	ACC
	reti 
; Obsluha prerueni INT 1
Int_1:
	cpl	p1.5		; Ladeni
	push	ACC
	push	PSW
	clr	C		; Vynuluju si C
	mov	A,citac_D	; Nacte spodni byte do A
	jnb	smer_D,Int1_dec	; Podle smetu toceni cidla bud odecte nebo pricte
	add	A,#1		; Inkrementuje spodni byte citace
	mov	citac_D,A	; Ulozei spodniho byte 
	mov	A,citac_D+1	; Nacteni horniho byte do A
	addc	A,#0		; Inkrementuje horni byte pokud nastalo C
	mov	citac_D+1,A	; Ulozeni horniho byte
	;****** Zajisteni spravne delky
	rlc	A		; Test na zapornost ci kladnost
	jc	Int1_konec	; Pokud je zaporny nemohlo pretect pri pricitani prez rozsah citace
	setb	C		; * Odecteni Rozsahu
	mov	A,citac_D		; Lo byte
	subb	A,max_D
	mov	A,citac_D+1		; Hi byte
	subb	A,max_D+1
	jc	Int1_konec
	mov	citac_D+1,max_Dm+1
	mov	citac_D,max_Dm
Int1_konec:
	pop	PSW
	pop	ACC
	reti 
Int1_dec:
	subb	A,#1		; Dekrementuje spodni byte citace
	mov	citac_D,A	; Ulozei spodniho byte 
	mov	A,citac_D+1	; Nacteni horniho byte do A
	subb	A,#0		; Dekrementuje se horni byte pokud nastalo C
	mov	citac_D+1,A	; Ulozeni horniho byte
	;****** Zajisteni spravne delky
	rlc	A		; Test na zapornost ci kladnost
	jnc	Int0_konec	; Pokud je kladny nemohlo pretect pri odcitani prez rozsah citace
	setb	C		; * Odecteni Rozsahu
	mov	A,citac_D		; Lo byte
	addc	A,max_D
	mov	A,citac_D+1		; Hi byte
	addc	A,max_D+1
	jc	Int1_konec
	mov	citac_D+1,max_D+1
	mov	citac_D,max_D
	pop	PSW
	pop	ACC
	reti 
;****** Prijem ze seriove linky
Serial:	mov	A,SBUF
	clr	RI
;######## Q				Pozadavek vypisu citacu
	cjne	A,#'Q',dalsi_znak_1
	; ***** Odeslani Reklazcenze
	clr	C			
	clr	EA			; Zakaz preruseni
	 mov	temp,citac_R
	 mov	temp+1,citac_R+1
	setb	EA			; Povoleni preruseni
	mov	A,citac_R+1		; Test na kladnost 
	rlc	A			; C = 1 zaporny , C = 0 kladny
	mov	A,#'+'			; Znamenko na plus
	jnc	ser_Q_1			; Pokud je C = 1 udela NEG2
	mov	R0,#citac_R
	call	NEG_2			; Dvojkovy doplnek
	mov	A,#'-'			; Znamenko na minus
ser_Q_1:
	jnb	TI,$
	clr	TI
	mov	SBUF,A			; Odeslani znamenka
	call	HEX_BCD			; Prevod cisla na BCD
	jnb	TI,$			; Ceka na TI
	clr	TI
	mov	SBUF,#09h		; Odesle <TAB>
	; ***** Odeslani Deklinace
	clr	C
	clr	EA			; Zakaz preuseni
	 mov	temp,citac_D
	 mov	temp+1,citac_D+1
	setb	EA			; Povoleni preruseni
	mov	A,citac_D+1		; Test na kladnost 
	rlc	A			; C = 1 zaporny , C = 0 kladny
	mov	A,#'+'			; Znamenko na plus
	jnc	ser_Q_2			; Pokud je C = 1 udela NEG2
	mov	R0,#citac_D
	call	NEG_2			; Dvojkovy doplnek
	mov	A,#'-'			; Znamenko na minus
ser_Q_2:
	jnb	TI,$			; Ceka na TI
	clr	TI
	mov	SBUF,A			; Odeslani znamenka
	call	HEX_BCD			; Prevod cisla na BCD
	jnb	TI,$			; Ceka na TI
	clr	TI
	mov	SBUF,#0Dh		; Odesle <CR>
	ret			
dalsi_znak_1:
;######## R				Nastaveni rozliseni
	cjne	A,#'R',dalsi_znak_2
	mov	temp,#0			; * Vynulovani temp
	mov	temp+1,#0
R_znovu:
	jnb	RI,$			; Ceka na Dalsi byte
	clr	RI
	mov	A,SBUF
	cjne	A,#01h,R_mon51		; mon51
	jmp	R_znovu			; mon51
dalsi_znak_2:
	jmp	dalsi_znak_21
R_mon51:				; mon51
	cjne	A,#0dh,R_dal		; Pokud prisel <CR> ulozi D a potvrdi
	clr	C			
	mov	A,temp+1		; * Podeleni dvema (mam kladny a zaporny cisla)
	rrc	A
	mov	temp+1,A
	mov	A,temp
	rrc	A
	mov	temp,A
	clr	C			; * Odecteni jednicky od kladne meze
	subb	A,#1
	mov	B,A
	mov	A,temp+1
	subb	A,#0
	clr	EA			; Zakaz preruseni
	 mov	max_D,B			; * Ulozeni prijmute R
	 mov	max_D+1,A
	setb	EA			; Povoleni preruseni
	mov	R0,#temp
	setb	C
	call	NEG_2			; Dvojkovy doplnek
	clr	EA			; Zakaz preuseni
	 mov	max_Dm,temp		; * Ulozeni prijmute D ve dvojkovem doplnku
	 mov	max_Dm+1,temp+1
	setb	EA 			; Povoleni preruseni
	jnb	TI,$			; Ceka na TI
	clr	TI
	mov	SBUF,#'R'		; Odesle potvrzeni
	ret
R_dal:	cjne	A,#09h,R_dal_1		; Pokud prisel <TAB> ulozi R
	clr	C			
	mov	A,temp+1		; * Podeleni dvema (mam kladny a zaporny cisla)
	rrc	A
	mov	temp+1,A
	mov	A,temp
	rrc	A
	mov	temp,A
	clr	C			; * Odecteni jednicky od kladne meze
	mov	A,temp
	subb	A,#1
	mov	B,A
	mov	A,temp+1
	subb	A,#0
	clr	EA			; Zakaz preuseni
	 mov	max_R,B			; * Ulozeni prijmute R
	 mov	max_R+1,A
	setb	EA 			; Povoleni preruseni
	mov	R0,#temp
	setb	C
	call	NEG_2			; Dvojkovy doplnek
	clr	EA			; Zakaz preuseni
	 mov	max_Rm,temp		; * Ulozeni prijmute R ve dvojkovem doplnku
	 mov	max_Rm+1,temp+1
	setb	EA 			; Povoleni preruseni
	mov	temp,#0			; * Vynulovani temp
	mov	temp+1,#0
	jmp	R_znovu			; Pokracuje
R_dal_1:
	call	BCD_HEX			; Prevadi prijmute znaky na cislo
	jmp	R_znovu
dalsi_znak_21:
;######## I				Nastaveni citacu
	cjne	A,#'I',dalsi_znak_3
	mov	temp,#0		; * Vynulovani temp
	mov	temp+1,#0
I_znovu:
	jnb	RI,$			; Ceka na Dalsi byte
	clr	RI
	mov	A,SBUF
	cjne	A,#01h,I_mon51	; mon51
	jmp	I_znovu		; mon51
I_mon51:				; mon51
	cjne	A,#0dh,I_dal	; Pokud prisel <CR> ulozi D a potvrdi
	setb	C			; * Odesteni (max_D)+1	(ofsetu)
	mov	A,temp
	subb	A,max_D
	mov	temp,A
	mov	A,temp+1
	subb	A,max_D+1
	mov	temp+1,A
;	jnc	I_nedoplnekD	; Preteklo to pod nulu -> dvojkovy dopnek
;	setb	C			; * Dvojkovy doplnek
;	mov	R0,temp
;	call	NEG_2			
;I_nedoplnekD:
	clr	EA			; Zakaz preruseni
	 mov	citac_D,temp	; * Ulozeni prijmute D
	 mov	citac_D+1,temp+1
	setb	EA			; Povoleni preruseni
	jnb	TI,$			; Ceka na TI
	clr	TI
	mov	SBUF,#'R'		; Odesle potvrzeni
	ret
I_dal:	cjne	A,#09h,I_dal_1		; Pokud prisel <TAB> ulozi R
	setb	C			; * Odesteni (max_R)+1	(ofsetu)
	mov	A,temp
	subb	A,max_R
	mov	temp,A
	mov	A,temp+1
	subb	A,max_R+1
	mov	temp+1,A
;	jnc	I_nedoplnekR	; Preteklo to pod nulu -> dvojkovy dopnek
;	setb	C			; * Dvojkovy doplnek
;	mov	R0,temp
;	call	NEG_2			
;I_nedoplnekR:
	clr	EA			; Zakaz preruseni
	 mov	citac_R,temp	; * Ulozeni prijmute R
	 mov	citac_R+1,temp+1
	setb	EA			; Povoleni preruseni
	mov	temp,#0		; * Vynulovani temp
	mov	temp+1,#0
	jmp	I_znovu		; Pokracuje
I_dal_1:
	call	BCD_HEX		; Prevadi prijmute znaky na cislo
	jmp	I_znovu

dalsi_znak_3:
;######## A				Nastaveni priznaku aktivace
	cjne	A,#'A',dalsi_znak_4
	setb	Ouranos_flag	; Nasteneni flagu inicializace
dalsi_znak_4:
;######## a				Doraz na bit aktivace
	cjne	A,#'a',dalsi_znak_5
	jnb	Ouranos_flag,a_dal
	jnb	TI,$
	clr	TI
	mov	SBUF,#'Y'		; Flag je nastaven
	ret
a_dal:
	jnb	TI,$
	clr	TI
	mov	SBUF,#'N'		; Flag neni nastaven
	ret	
dalsi_znak_5:
	ret
;******* Preteceni ?? cislo ve dvojkovym dopnku
; V R0 je adresa Lo byte citace v R1 je adresa Lo bytu Rozsahu
; Pokud pretekl, nebo podtekl tak NENI nastaveno C
; Pouziva ACC , R0, R1, C 
preteceni:
	clr	C
	inc	R0		; Ukazovatko  na Hi
	mov	A,@R0		; * Zjisteni jestli je + nebo -
	rlc	A		; Nacteni vrchniho bytu citace
	dec	R0
	jnc	p_kladny	
	clr	C		; * Pricteni Rozsahu
	mov	A,@R0		; Lo byte
	addc	A,@R1
	inc	R0
	inc	R1
	mov	A,@R0		; Hi byte
	addc	A,@R1
	ret
p_kladny:			; * Odecteni rozsahu
	mov	A,@R0		; Lo byte
	subb	A,@R1
	inc	R0
	inc	R1
	mov	A,@R0		; Hi byte
	subb	A,@R1
	ret
;****** HEXtoBCD
; V temp je cislo, ktery se bude prevadet
; Pouziva C , Acc , B , R0 , R1 , R2
HEX_BCD:
	mov	R2,#5		; Inicializace pocitadla
hex_znovu:
	mov	R1,temp	; Lo byte do R1
	mov	A,temp+1	; Presun Hi bytu do A	
	mov	B,#10		; Delim deseti
	div	AB		; Vydeleni
	mov	temp+1,A	; Uchovani Hi bytu

	mov	A,B		; Do A nasune zbytek po deleni
	swap	A		; Prohodi Lo a Hi cast Acc
	mov	R0,A		; Schova A do R0
	mov	A,R1		; Nacte Lo byte
	swap	A		; Prohodi Lo a Hi cast Acc
	anl	A,#0fh	; Vynuluje Hi pulku
	add	A,R0		; Spoji zbytek na Hi(Acc) a Hi(Lo bytu) na Lo(Acc)
	mov	B,#10		; * Vydeli 10
	div	AB
	swap	A		; Prohodi Lo(Acc) a Hi(Acc)
	mov	temp,A	; Ulozi to do temp

	mov	A,B		; Do A nasune zbytek po deleni
	swap	A		; Prohodi Lo a Hi cast Acc
	mov	R0,A		; Schova A do R0
	mov	A,R1		; Nacte Lo byte
	anl	A,#0fh	; Vynuluje Hi pulku
	add	A,R0		; Spoji zbytek na Hi(Acc) a Lo(Lo bytu) na Lo(Acc)
	mov	B,#10		; * Vydeli 10
	div	AB
	add	A,temp	; Spoji vysledek do kupy
	mov	temp,A	; ulozeni do temp
	push 	B		; schova nejnizsi cislici
	djnz	R2,hex_znovu

	mov	R2,#5		; Inicializace pocitadla
hex_znovu1:
	pop	ACC		; !!!! pro ladeni
	add	A,#030h	; Prevod Cislo -> ASCII
	jnb	TI,$		; ceka na TI
	clr	TI		; Schozeni priznaku
	mov	SBUF,A	; Odeslani cislice
	djnz	R2,hex_znovu1
	ret
;****** BCDtoHEX
; V A je cislo, ktery se bude prevadet
; Vysledek je v temp
; Pouziva C , Acc , B , R0 
BCD_HEX:
	subb	A,#030h	; ASCII -> cislo
	mov	R0,A		; Schovam si A
	mov	A,temp	; * Vynasobim LO(temp) * 10
	mov	B,#10
	mul	AB
	mov	temp,A	; Ulozim LO
	push	B		; Schovam HI
	mov	A,temp+1	; * Vynasobim HI(temp) * 10
	mov	B,#10
	mul	AB
	pop	B		; * Prictu HI(byte) z minula k nynejsimu LO(byte)
	add	A,B
	mov	B,A		; Presunu A do B
	mov	A,temp	; Nahraju A hodnotou LO(byte)
	clr	C
	add 	A,R0		; * Prictu prijmutou cislici
	mov	temp,A	; Ulozeni do temp
	mov	A,B		 
	addc	A,#0
	mov	temp+1,A	; Ulozeni do temp+1	
	ret
;****** Dvojkovy dopnek 2 bytu 
; Vystup R0 = LO(adresa) , C = 1 
; Vysledek je v temp
; Pouziva C, Acc , R0 , temp
NEG_2:	inc	R0	; Ukazuje na Hi
	mov	A,@R0		; Nacteni Hi
	xrl	A,#0ffh		; Negace
	mov	temp+1,A	; Ulozeni do temp+1
	dec	R0		; Ukazuje na Lo
	mov	A,@R0		; Nacteni Lo
	xrl	A,#0ffh		; Negace
	addc	A,#0		; Je nastaven C -> pricte jednicku k Lo
	mov	temp,A		; Ulozeni Lo do temp
	mov	A,temp+1	; Nahrani Hi
	addc	A,#0		; Pricte podle predchoziho vysledku
	mov	temp+1,A	; Ulozeni Hi do temp+1
	ret
start:
;****** Inicializace serioveho kanalu cit1 a cit0 mode 1
	mov 	A,tmod	; GATE=0 , C/T = 0 , Mod 2
	anl	A,#00101111b
	orl	A,#00100000b
	mov	tmod,A
	mov     th1,#0f3h 	; 9600 baud pro 24MHz  0xfd je pro 11.0592MHz
	mov     scon,#52h	; Nasteveni parametru seriovy linky 8b, 1s, Bez
	mov	pcon,#10000000b	; Nastaveni smad na 1 pro 24 MHz
	setb 	TR1 		; Spousti citac casovace 1
;****** Nastaveni Interaptu INT 0 a INT 1
	setb	IT0		; Nastaveni preruseni INT0 od hrany
	setb	EX0		; Povoleni preruseni od INT0
	setb	IT1		; Nastaveni preruseni INT1 od hrany
	setb	EX1		; Povoleni preruseni od INT1
	setb	EA		; Globalni povoleni preruseni
;****** Inicializace Promennych 
	clr	Ouranos_flag	; Shozeni priznaku inicializace
	mov	max_D,#087h		;* Inicializace citace na velikost cidla 2500 impulzu
	mov	max_D+1,#013h
	mov	max_Dm,#078h	
	mov	max_Dm+1,#0ech
	mov	max_R,#087h
	mov	max_R+1,#013h
	mov	max_Rm,#078h
	mov	max_Rm+1,#0ech	;*

;****** Hlavni telo programu
znovu:
	jnb	RI,serial_dal	; Dotaz na prijem ze seriove linky
	call	Serial		; Obsluha seriove linky	
serial_dal:
	jmp	znovu
; ***** Deklarace promennych 
bseg	
Ouranos_flag:	dbit	1	; Flag ktery uzcuje zda je poloha aktualni
dseg	
	org	Promenne_citace
citac_R:	ds	1h		; Citac polohy Reklascenze
citac_R1:	ds	1h
citac_D:	ds	1h		; Citac	polohy Deklinace
citac_D1:	ds	1h
max_R:		ds	1h	; Maximalni hodnota R
max_R1:		ds	1h
max_Rm:		ds	1h	; Maximalni hodnota R
max_R1m:	ds	1h
max_D:		ds	1h	; Maximalni hodnota D
max_D1:		ds	1h
max_Dm:		ds	1h	; Maximalni hodnota D
max_Dm1:	ds	1h
temp:		ds	1h
temp1:		ds	1h
END
