;.device AT90S1200 ;Prohibits use of non-implemented instructions
.nolist
.include "1200def.inc"
.list
; ###################################################
; zacatek programu
; ***** Deklarace vstupni pinu a portu se vstupy z IRC
.equ R_A = 0 ;2
.equ R_B = 1 ;4
.equ D_A = 3 ;3
.equ D_B = 4 ;5
.equ port = pinB

.equ maska_R = 0b00010000 ;0b00100000 jednicka na pozici D_B
.equ maska_D = 0b00000010 ;0b00010000 jednicka na pozici R_B
.equ maska_RD= 0b00011000 ;0b00101000 jednicka na pozici D_A, D_B
.equ maska_DR= 0b00000011 ;0b00010100 jednicka na pozici R_A, R_B
; ***** Deklarace vystupnich pinu na SMER a IRQ
.equ port_o = portD
.equ mask_pO = DDRD

.equ S_R = 5
.equ IRQ_R = 2
.equ S_D = 6
.equ IRQ_D = 3

; ***** Deklarace promennych 
.dseg
.def akt_st = r16
.def min_st = r17
.def temp = r18
.def R_smer = r19
.def D_smer = r20

.cseg
.org 0x0
rjmp start
.org 0x002
.org 0x004
reti
.org 0x005
start:
; rjmp start
;******* Inicializace portu
in r18,WDTCR ;* Zastavi se wotch dock
clt
bld r18,3
out WDTCR,r18
set
clr r18 ;* Nastaveni bitu S_R,S_D,IRQ_R,IRQ_R jako vystupnich
bld r18,S_D
bld r18,S_R
bld r18,IRQ_D
bld r18,IRQ_R
out mask_pO,r18
;*************** Vyhodnoceni stavu signalu na IRC cidle, je to PROCEDURA !!!
;******* Sejmuti stavu
stav_IRC:
mov min_st,temp ; Aktualizace hodnot stavu
in akt_st,port ; Nacteni stavu portu
mov temp,akt_st ; Zalohovani dat aktuelniho stavu
nop
sbi port_o,IRQ_R ; Zruseni pozadavku IRQ_R
sbi port_o,IRQ_D ; Zruseni pozadavku IRQ_D
cpse akt_st,min_st ; Zjisteni zda doslo ke zmene
rjmp zmena_IRC
rjmp stav_IRC ; Pokud nedoslo ke zmene, tak pokracuje
;******* Zjisteni zmeny
zmena_IRC:
eor akt_st,min_st ; Po ukonceni instrukce je jednicka na miste, kde doslo ke zmene
andi akt_st,maska_DR ; vymaskuje D
brne zmena_R_0 ; Pokud je Z=0 potom byla zmena na R a skoci na zmena_R_0 
zmena_IRC_dale: 
mov akt_st,temp ; Obnoveni hodnoty v akt_st
eor akt_st,min_st ; Po ukonceni instrukce je jednicka na miste, kde doslo ke zmene
andi akt_st,maska_RD ; vymaskuje R
brne zmena_D_0 ; Pokud je Z=0 potom byla zmena i na D a skoci na zmena_D_0 
mov min_st,temp ; Aktualizace hodnot stavu
rjmp stav_IRC
;******* Zjisteni smeru D 
zmena_D_0: ; jinac byla zmena na D
sbrc min_st,D_A ; Pokud je D_A(-1) = 0 preskoci nasledujici instr.
rjmp zmena_D_1 ; Pokud je D_A(-1) = 1 skoci na zmena_D_1
sbrs temp,D_B ; Je D_A(-1) = 0 a D_B = 1, pokud ano skoci na D_SMER_1
rjmp D_SMER_0 ; je D_A(-1) = 0 a D_B = 0, pokud ano skoci na D_SMER_0
D_SMER_1:
cbi port_o,IRQ_D ; Pulz informujici o zmene
cbi port_o,S_D ; smer_D = 0
; mov min_st,temp ; Aktualizace hodnot stavu
rjmp stav_IRC
D_SMER_0:
cbi port_o,IRQ_D ; Pulz informujici o zmene
sbi port_o,S_D ; smer_D = 1
; mov min_st,temp ; Aktualizace hodnot stavu
rjmp stav_IRC
zmena_D_1:
sbrc temp,D_B ; Je D_A(-1) = 1 a D_B = 0, pokud ano skoci na D_SMER_1
rjmp D_SMER_0 ; Je D_A(-1) = 1 a D_B = 1, pokud ano skoci na D_SMER_0
;D_SMER_1:
cbi port_o,IRQ_D ; Pulz informujici o zmene
cbi port_o,S_D ; D_smer = 0
; mov min_st,temp ; Aktualizace hodnot stavu
rjmp stav_IRC 
;****** Zjisteni smeru R
zmena_R_0:
sbrc min_st,R_A ; Pokud je R_A(-1) = 0 preskoci nasledujici instr.
rjmp zmena_R_1 ; Pokud je R_A(-1) = 1 skoci na zmena_R_1
sbrs temp,R_B ; Je R_A(-1) = 0 a R_B = 1, pokud ano skoci na R_SMER_0
rjmp R_SMER_0 ; je R_A(-1) = 0 a R_B = 0, pokud ano skoci na R_SMER_1
R_SMER_1:
cbi port_o,IRQ_R ; Pulz informujici o zmene
cbi port_o,S_R ; smer_R = 0
rjmp zmena_IRC_dale 
R_SMER_0:
cbi port_o,IRQ_R ; Pulz informujici o zmene
sbi port_o,S_R ; smer_R = 1
rjmp zmena_IRC_dale 
zmena_R_1:
sbrc temp,R_B ; Je R_A(-1) = 1 a R_B = 0, pokud ano skoci na R_SMER_1
rjmp R_SMER_0 ; Je R_A(-1) = 1 a R_B = 1, pokud ano skoci na R_SMER_0
;R_SMER_1:
cbi port_o,IRQ_R ; Pulz informujici o zmene
cbi port_o,S_R ; R_smer = 0
rjmp zmena_IRC_dale

rjmp stav_IRC
